<!DOCTYPE html>
<html>

<head lang="es">
	<meta charset="utf-8">
	<title>Trabajo en grupo TG2</title>
	<link rel="stylesheet" href="style.css">
	<style>
		table,
		th,
		td {
			border: 1px solid black;
		}
	</style>
</head>

<body>
	<header>
		<h1>Desarrollo con Tecnologias Emergentes. Curso 2019-20 <br>
			Trabajo TG2 del grupo M2<br>
			Titulo: TG2. Evaluar y comparar dos tecnologias emergentes</h1>
	</header>
	<nav>
		<ul>
			<li><a href="#1">1. Informacion general</a></li>
			<li><a href="#2">2. Descripcion de las tecnologias</a></li>
			<li><a href="#3">3. Criterios de comparacion</a></li>
			<li><a href="#4">4. Evaluacion de los criterios por categoria</a></li>
			<li><a href="#5">5. Comparacion de las tecnologias</a></li>
			<li><a href="#6">6. Recomendaciones</a></li>
		</ul>
	</nav>

	<main>
		<section id=1">
			<h2>1. Informacion general</h2>
			<h3>1.1 Autores</h3>
			<p>JAIME JIMENO MARTÍN</p>
            <p>JULIO CÉSAR RAMÍREZ ORÉ</p>
            <p>ESTELA MONZÓN FRASQUET</p>
            <p>FRANCISCO GARCÍA-MORALES HURTADO</p>
            <p>DANIEL BOYANO GONZÁLEZ </p>
			<h3>1.2 Proyecto Scrum y repositorio en GitLab</h3>
			<p>
				<a href="https://gitlab.com/dte2020/m5/tg2/">https://gitlab.com/dte2020/m2/tg2_/</a>".</p>
			<p>En ese proyecto debera haber un Sprint (Milestone) finalizado con el nombre "TG2".</p>
			<h3>1.3 Burndown chart</h3>
			<img src="burndown.png">
			<h3>1.4 Presentacion del trabajo</h3>
			<a href="tg2.pptx">Presentacion con diapositivas del trabajo TG2</a></p>
		</section>
		<section id="2">
			<h2>2. Descripcion de las tecnologias</h2>
			<h3>2.1 Descripcion de la tecnologia 1</h3>
			<p>Es un software ORM, o un programa de mapeo objeto-relacional. Esto significa que es donde Java volcará los modelos de objetos 
			programados anteriormente para convertirlos en tablas, lo que es necesario para crear una base de datos. 
			Lo que al final conseguimos con esta tecnología es agilizar las relaciones entre la app y la base de datos, evitando, entre otras cosas, caer en código repetitivo. 
			Hibernate permite manejar la base de datos utilizando todas las características de la POO en Java mientras genera las sentencias SQL que sí entienden las bases de datos. 
			Para poder utilizarlo, es necesario tener conocimientos sobre programación en Java, bases de datos y lenguaje SQL.</p>
			
			
			<img src="foto1.jpg">
			<a href="https://ifgeekthen.everis.com/es/que-es-java-hibernate-por-que-usarlo"> Esta imagen muestra como se vuelca la aplicacion en Hibernate.</a>
			
			
			<img src="foto2.png">
			<a href="http://acodigo.blogspot.com/2017/03/spring-acceso-datos-con-hibernate-jpa.html"> Esta imagen representa como se convierten las clases objeto de Java en tablas SQL.</a>
			
			<h3>2.2 Descripcion de la tecnologia 2</h3>
			<p>iBatis es un framework que se ocupa de la capa de persistencia (persistence framework). 
			La funcion de este software es asociar objetos de modelo con sentencias SQL (escritas por el administrador), 
			lo que facilitará la utilización de la BBDD. iBatis incluye como componentes:
				- Data Mapper: interacción de datos entre objetos JAVA y la BBDD.
				- Data Access Object: oculta la persistencia de objetos y proporciona API de acceso a datos.</p>
			
			
			<img src="foto4.jpg">
			<a href="https://miblogtecnico.wordpress.com/tag/ibatis/"> Esta imagen representa la diferencia del mapeo entre iBatis y un ORM (como Hibernate).</a>
			
			<img src="foto5.jpg">
			<a href="https://www.slideshare.net/techmonkey4u/ibatis-1712114"> Esta imagen representa como iBatis asocia los objetos de modelo con sentencias SQL.</a>
			
			
		</section>
	<section id="3">
			<h2>3. Criterios de comparacion</h2>
			<h3>3.1 Categoría A: General</h3>
			<h4>3.1.1 Criterio A.1 Licencia</h4>
			<ul>
				<li>Descripción: Tipo de licencia de uso</li>
				<li>Tipo: texto libre</li>
			</ul>
			<h4>3.1.2 Criterio A.2 Requisitos</h4>
			<ul>
				<li>Descripción: infraestructura necesaria para implantar la tecnología</li>
				<li>Tipo: texto libre</li>
			</ul>
			<h4>3.1.3 Criterio A.3 Coste</h4>
			<ul>
				<li>Descripción: Coste por la adquisición de la licencia</li>
				<li>Tipo: numérico</li>
			</ul>
			<h4>33.1.4 Criterio A.4 Costes Asociados</h4>
			<ul>
				<li>Descripción: Costes asociados debidos a la implantación de la tecnología</li>
				<li>Tipo: numérico</li>
			</ul>
			<h4>3.1.5 Criterio A.5 Mantenimiento y Soporte</h4>
			<ul>
				<li>Descripción: Frecuencia con la que se actualiza y parchea la tecnología y Soporte ofrecido por la tecnología</li>
				<li>Tipo: texto libre</li>
			</ul>
			<h4>3.1.6 Criterio A.6 Uso</h4>
			<ul>
				<li>Descripción: Cantidad de licencia vendidas o de descarga, ver el volumen de uso de la tecnología</li>
				<li>Tipo:texto libre</li>
			</ul>
			<h4>3.1.7 Criterio A .7 Material de apoyo</h4>
			<ul>
				<li>Descripción: Material complementario ya sea de la compañía o de la comunidad, siendo desde software hasta material didáctico</li>
				<li>Tipo:texto libre</li>
			</ul>
			
			<h3>3.2 Categoría B: Adaptación</h3>
			<h4>3.2.1 Criterio B.1 Modificación programa</h4>
			<ul>
				<li>Descripción: Número de líneas de código que se necesitan cambiar para adaptar el programa a la herramienta.</li>
				<li>Tipo: texto libre</li>
			</ul>
			<h4>3.2.2 Criterio B.2 Aprendizaje</h4>
			<ul>
				<li>Descripción: Tiempo medio necesario para comprender y dominar la herramienta</li>
				<li>Tipo: texto libre</li>
			</ul>
			<h4>3.2.3 Criterio B.3 Portabilidad</h4>
			<ul>
				<li>Descripción: capacidad de adaptación en las diferentes de SQL</li>
				<li>Tipo: texto libre</li>
			</ul>
			<h3>3.3 Categoría C: Funcionamiento</h3>
			<h4>3.3.1 Criterio C.1: Requisitos hardware recomendados</h4>
			<ul>
				<li>Descripción: componentes hardware que se recomiendan</li>
				<li>Tipo: texto libre</li>
			</ul>
			<h4>3.3.2 Criterio C.2: Programas completarías</h4>
			<ul>
				<li>Descripción: componentes software necesarios para implementar la tecnología y software que la complementa</li>
				<li>Tipo: texto libre</li>
			</ul>
			<h4>3.3.3 Criterio C.3: Implementación</h4>
			<ul>
				<li>Descripción: Como se implementa la tecnología en el sistema</li>
				<li>Tipo: texto libre</li>
			</ul>
			<h4>3.3.4 Criterio C.4: Optimización</h4>
			<ul>
				<li>Descripción: Cantidad de líneas de código que reduce respecto a otras implementaciones</li>
				<li>Tipo: texto libre</li>
			</ul>
			<h4>3.3.5 Criterio C.5 Compatibilidad Windows</h4>
			<ul>
				<li>Descripción: observar la compatibilidad con Windows </li>
				<li>Tipo: booleano</li>
			</ul>
			<h4>3.3.6 Criterio C.6 Compatibilidad Linux</h4>
			<ul>
				<li>Descripción: observar si es compatible con distribuciones Linux</li>
				<li>Tipo: booleano</li>
			</ul>
			<h4>3.3.7 Criterio C.7 Compatibilidad MacOS</h4>
			<ul>
				<li>Descripción: observar si es compatible con MacOS</li>
				<li>Tipo: booleano</li>
			</ul>
			<h4>3.3.8 Criterio C.8 Configurabilidad</h4>
			<ul>
				<li>Descripción: definir la adaptabilidad de la herramienta</li>
				<li>Tipo: texto libre</li>
			</ul>
			<h4>3.3.9 Criterio C.9 Ajuste</h4>
			<ul>
				<li>Descripción: facilidad con la que el usuario puede ajustar el software a su medida</li>
				<li>Tipo: texto libre</li>
			</ul>
			<h4>3.3.10 Rentabilidad</h4>
			<ul>
				<li>Descripción: aumento de la productividad que ofrece frente a la opción de no implantarla</li>
				<li>Tipo: texto libre</li>
			</ul>

		</section>

		<section id="4">
			<h2>4. Evaluacion de los criterios por categoria</h2>
			<h3>4.1 Evaluacion de los criterios para la tecnologia 1</h3>
			
			<table>
				<tr>
					<th>Criterio</th>
					<th>Evaluacion</th>
				</tr>
				<tr>
					<td>Criterio A.1: Licencia</td>
					<td>GNU LGPL</td>
				</tr>
				<tr>
					<td>Criterio A.2: Requisitos</td>
					<td>Las tablas deben tener una clave primaria</td>
				</tr>
				<tr>
					<td>Criterio A.3: Coste</td>
					<td>0</td>
				</tr>
				<tr>
					<td>Criterio A.4: Costes Asociados</td>
					<td>0</td>
				</tr>
				<tr>
					<td>Criterio A.5: Mantenimiento y soporte</td>
					<td>Genos Open Source da soporte a hibernate, y como es un software opensource existen distintos blogs donde tambien se le da soporte.</td>
				</tr>
				<tr>
					<td>Criterio A.6: Uso</td>
					<td>No se puede saber la cantidad exacta de usuarios de este software ya que es un framework de Java.</td>
				</tr>
				<tr>
					<td>Criterio A.7: Material de apoyo</td>
					<td>El material de apoyo es muy amplio y muy variado se centra en posts, libros, revistas...</td>
				</tr>
				<tr>
					<td>Criterio B.1: Modificación del programa</td>
					<td>Al tratarse de una herramienta de mapeo objeto/relacional , ayudandonos a ahorrar lineas de codigo.</td>
				</tr>
				<tr>
					<td>Criterio B.2: Aprendizaje</td>
					<td>Dependen de las nociones del usuario, ya que, si tiene altos conocimientos de programacion no le resultara muy dificil hacerse con ello.</td>
				</tr>
				<tr>
					<td>Criterio B.3: Portabilidad</td>
					<td>Tiene alta portabilidad ya que se ajusta a cualquier base de datos relacional.</td>
				</tr>
				<tr>
					<td>Criterio C.1: Requisitos hardware recomendado</td>
					<td>Depende de la base de datos a la que se vaya a relacional, pero normalmente solo es necesario un CPU y un monitor.</td>
				</tr>
				<tr>
					<td>Criterio C.2: Programas complementarios</td>
					<td>Spring Framework provee amplio soporte a hibernate (implementaciones de DAO)</td>
				</tr>
				<tr>
					<td>Criterio C.3: Implementación</td>
					<td>Se puede descargar desde tools dependiendo de la IDE de Java que utilicemos.</td>
				</tr>
				<tr>
					<td>Criterio C.4: Optimización</td>
					<td>No se puede asegurar el numero de lineas de codigo que se puede ahorrar, pero esta herramienta es muy util y ahorra bastantes lineas de codigo.</td>
				</tr>
				<tr>
					<td>Criterio C.5: Compatibilidad Windows</td>
					<td>Sí</td>
				</tr>
				<tr>
					<td>Criterio C.6: Compatibilidad Linux</td>
					<td>Sí</td>
				</tr>
				<tr>
					<td>Criterio C.7: Compatibilidad MacOs</td>
					<td>Sí</td>
				</tr>
				<tr>
					<td>Criterio C.8: Configurabilidad</td>
					<td>La herramienta esta preparada para cualquier adaptacion a una base de datos relacional.</td>
				</tr>
				<tr>
					<td>Criterio C.9: Ajuste</td>
					<td>LEsta herramienta nos ayudara a poder realizar las consultas de una manera mas facil.</td>
				</tr>
				<tr>
					<td>Criterio C.10: Rentabilidad</td>
					<td>Al tratarse de una herramienta open source que te ayuda a la hora del mapeo objeto/relacional, podemos deducir que la rentabilidad de esta herramienta es muy alta.</td>
				</tr>
			</table>

			<h3>4.2 Evaluacion de los criterios para la tecnologia 2</h3>
			
			<table>
				<tr>
					<th>Criterio</th>
					<th>Evaluacion</th>
				</tr>
				<tr>
					<td>Criterio A.1: Licencia</td>
					<td>Licencia Apache 2.0</td>
				</tr>
				<tr>
					<td>Criterio A.2: Requisitos</td>
					<td>No puede ser utilizado cuando se requiere una automatización total y transparente de la persistencia</td>
				</tr>
				<tr>
					<td>Criterio A.3: Coste</td>
					<td>0</td>
				</tr>
				<tr>
					<td>Criterio A.4: Costes Asociados</td>
					<td>0</td>
				</tr>
				<tr>
					<td>Criterio A.5: Mantenimiento y soporte</td>
					<td>Principalmente Oracle, pero existes paginas y foros especializado, a parte de actualizaciones anuales aproximadamente.</td>
				</tr>
				<tr>
					<td>Criterio A.6: Uso</td>
					<td>No se puede saber la cantidad exacta de usuarios de este software ya que es un framework de Java.</td>
				</tr>
				<tr>
					<td>Criterio A.7: Material de apoyo</td>
					<td>El material de apoyo es muy amplio y muy variado se centra en posts, libros, revistas...</td>
				</tr>
				<tr>
					<td>Criterio B.1: Modificación del programa</td>
					<td>Este framework se ocupa de la persistencia(se situa entre la capa de negocio y la capa de base de datos). Simplifica la implementacion del patron de diseño Direct Access Objects (DAO) y la persistencia de objetos en bases de datos relacionales.</td>
				</tr>
				<tr>
					<td>Criterio B.2: Aprendizaje</td>
					<td>Dependen de las nociones del usuario, ya que, si tiene altos conocimientos de programacion y SQL no le resultara muy dificil hacerse con ello.</td>
				</tr>
				<tr>
					<td>Criterio B.3: Portabilidad</td>
					<td>Entre Java y .NET; entre diferentes proveedores de base de datos.</td>
				</tr>
				<tr>
					<td>Criterio C.1: Requisitos hardware recomendado</td>
					<td>Depende de la base de datos a la que se vaya a relacional, pero normalmente solo es necesario un CPU y un monitor.</td>
				</tr>
				<tr>
					<td>Criterio C.2: Programas complementarios</td>
					<td>Spring Framework provee amplio soporte complementaria a iBatis como un conjunto de plantillas para hacerlo mas manejable</td>
				</tr>
				<tr>
					<td>Criterio C.3: Implementación</td>
					<td>Nos permite la articulacion flexible de la base de datos y la aplicacion mediante la asignacion de la entrada y salida de la base de datos a los objetos de dominio, introduciendo asi una capa de abstraccion. La asignacion se realiza mediantes archivos XML que contienen consultas SQL.</td>
				</tr>
				<tr>
					<td>Criterio C.4: Optimización</td>
					<td>No se puede asegurar el numero de lineas de codigo que se puede ahorrar, pero esta herramienta es muy util para el manejo de la capa de persistencia mediante la utilizacion de interfaces(iBatis DAO).</td>
				</tr>
				<tr>
					<td>Criterio C.5: Compatibilidad Windows</td>
					<td>Sí</td>
				</tr>
				<tr>
					<td>Criterio C.6: Compatibilidad Linux</td>
					<td>Sí</td>
				</tr>
				<tr>
					<td>Criterio C.7: Compatibilidad MacOs</td>
					<td>Sí</td>
				</tr>
				<tr>
					<td>Criterio C.8: Configurabilidad</td>
					<td>La herramienta esta preparada para cualquier adaptacion a una base de datos relacional.</td>
				</tr>
				<tr>
					<td>Criterio C.9: Ajuste</td>
					<td>LEsta herramienta nos ayudara a poder realizar las consultas de una manera mas facil, mendiante sentencias SQL aunque nuestra base de datos este poco normalizada.</td>
				</tr>
				<tr>
					<td>Criterio C.10: Rentabilidad</td>
					<td>Al tratarse de una herramienta open source que te ayuda a la hora del mapeo objeto/relacional, podemos deducir que la rentabilidad de esta herramienta es muy alta.</td>
				</tr>
			</table>


		</section>

		<section id="5">
			<h2>5. Comparacion de las tecnologias</h2>
					<h2>5. Comparacion de las tecnologias</h2>
			<p>
				Procedemos a realizar la comparación de las dos siguientes tecnologías: Hibernate e iBATIS.
				Los criterios a comparar que analizaremos y estudiaremos son los siguientes:
					•	General
					•	Adaptación
					•	Funcionamiento
			</p>

			<table>
				<tr>
					<th>Criterio</th>
					<th>Tecnologia 1: HIBERNATE</th>
					<th>Tecnologia 2: iBATIS</th>
					<th>Comentarios</th>

				</tr>
				<tr>
					<td>General</td>
					<td>Software limpio.Único requisito: tablas deben tener una clave primaria</p>
					<p>Gratuita y sin ningún coste asociado</p>
					<p>Genos Open Source realiza el soporte de esta tecnología</p>
					<p>Mantenimiento a cargo del desarrollado</p>
					<p>Herramienta de la plataforma Java</p>
					<p>Cantidad de usuarios inestimable</p>
					<p>Gran material de apoyo para aumentar los conocimientos de Hibernate</td>
					<td>Software libre y limpio
					<p>Requisitos: no utilizable cuando se requiere una automatización total y transparente de la persistencia, ni cuando se requiere soporte transparente y automático
					<p>Gratuita y sin ningún coste asociado</p>
					<p>Varias páginas realizan el soporte, dado que se trata de un software de código abierto. Un ejemplo es Oracle</p>
					<p>Mantenimiento a cargo del desarrollador</p>
					<p>Herramienta de la plataforma Java</p>
					<p>Cantidad de usuarios inestimable</p>
					<p>Gran material de apoyo para aumentar los conocimientos de iBATIS
					</td>
					<td>Ambas herramientas son muy recomendables, deberíamos estudiar a qué tipo de situacion nos enfrentamos para poder decantarnos por una u otra. No obstante, 
					Hibernate e iBATIS son dos de las herramientas más utilizadas en la actualidad. </td>
					
				
		
					
				</tr>
				<tr>
					<td>Adaptabilidad</td>
					<td>El aprendizaje depende de los conocimientos de programación del programador
					<p>No obstante, existe una gran cantidad de material de apoyo sobre esta tecnología</p>
					<p>Se ajusta a cualquier base de datos relacional</p>
					<p>Alta portabilidad</p></td>
					
					<td>Se encarga de la capa de persistencia
					</p>El aprendizaje depende de los conocimientos de programación del programador</p>
					</p>Portabilidad: entre Java y .NET; entre diferentes proveedores de base de datos</p>
					</td>
					<td>La conclusión que podemos sacar al comparar la adaptabilidad de ambas herramientas y haciendo un estudio más profundizado, es que iBATIS
					tiene más facilidades, por lo tanto, recomendaríamos esta herramienta dado que es más simple.</td>
					
				</tr>
				<tr>
				<td>Funcionamiento</td>
					<td>Hardware depende de la base de datos que se desee relacionar
					<p>Imprescindible la plataforma de Java, o por el contrario una que la incluya</p>
					<p>Descargable desde tools, y dependiendo de la BBDD que utilicemos se relacionará de una manera</p>
					<p>Optimiza el número de líneas de código (LOC)</p>
					<p>Alta compatibilidad con Windows</p>
					<p>Alta compatibilidad con Linux</p>
					<p>Alta compatibilidad con MacOs</p>
					<p>Se pue adaptar a una base de datos relacional </p>
					<p>Facilidad para realizar consultas</p>
					<p>Alta rentabilidad</p>
				</td>
					<td>Hardware depende de la base de datos que se desee relacionar
					<p>Spring es una herramienta que complementa iBatis, hace que iBatis sea más manejable</p>
					<p>Gran flexibilidad. Asignación mediante XML que contienen las consultas</p>
					<p>Optimiza el número de líneas de código (LOC)</p>
					<p>Alta compatibilidad con Windows</p>
					<p>Alta compatibilidad con Linux</p>
					<p>Alta compatibilidad con MacOs</p>
					<p>	Se puede adaptar a una base de datos relacional </p>
					<p>Facilidad para realizar consultas</p>
					<p>Rentable</td>
					<td>Ambas herramientas dependen de la base de datos que se desee relacionar y se pueden adaptar sin ningún problema siempre que el
					desarrollador realice los pasos correctamente. Son compatibles con Windows, Linux y MacOs. Consideramos que nos aporta más rentabilidad HIBERNATE, pero los procedimientos son 
					más complejos y por lo tanto, menos flexible.</td>
					

				</tr>
			
				
			</table>
		</section>
		
		<section id="6">
			<h2>6. Recomendaciones</h2>
			<p>Planteamos 2 situaciones diferentes.</p>
			<h3>6.1 Situacion A</h3>
			<h4>6.1.1 Descripcion de la situacion</h4>
			<p>Una empresa desea optimizar el desarrollo y volcado de datos anteriores, de una nueva base de datos SQL,
			con programación orientada a objetos y con un plazo de tiempo reducido </p>
			<h4>6.1.2 Recomendacion de la tecnología a utilizar</h4>
			<p>Proponemos HIBERNATE</p>
			<p>Criterios relevantes:</p>
			<table>
				<tr>
					<th>Criterios relevantes para la decision</th>
					<th>Ventajas tecnología 1</th>
					<th>Ventajas tecnología 2</th>
				</tr>
				<tr>
					<td>Agilidad de desarrollo</td>
					<td>Hibernate genera automátticamente el codigo SQL</td>
					<td>Con IBATIS hay que introducir todo manualmente</td>
				</tr>
				<tr>
					<td>Desarrollo futuro de la bbdd</td>
					<td>Hibernate es escalable</td>
					<td>IBATIS es menos adpatable</td>
				</tr>
				<tr>
					<td>Flexibilidad</td>
					<td>Hibernate usa un SQL relativamente independiente de la base de datos</td>
					<td>IBATIS usa un SQL más dependiente de la base de datos</td>
				</tr>
			</table>

			<h3>6.2 Situacion B</h3>
			<h4>6.2.1 Descripcion de la situacion</h4>
			<p>Queremos modificar nuestra base de datos introduciendo un nuevo modelo de negocio,
			 y eliminar la información repetitiva de nuestra base de datos.</p>
			<h4>6.2.2 Recomendacion de la tecnología a utilizar</h4>
			<p>Recomendamos IBATIS</p>
			<p>Criterios relevante:</p>
			<table>
				<tr>
					<th>Criterios relevantes para la decisión</th>
					<th>Ventajas tecnología 1</th>
					<th>Ventajas tecnología 2</th>
				</tr>
				<tr>
					<td>Adaptación nuevo modelo de negocio</td>
					<td>Hibernate genera el SQL para mapear objetos a tablas de la base de datos</td>
					<td>IBATIS es más flexible pues nosotros creamos el SQL</td>
				</tr>
				<tr>
					<td>Sencillez en los cambios</td>
					<td>En Hibernate los procedimientos son más complejos</td>
					<td>IBATIS tiene procedimientos relativamente sencillos de implantar</td>
				</tr>
				<tr>
					<td>Espacio ocupado</td>
					<td>Al generar el SQL automáticamente HIBERNATE requiere un mayor espacio</td>
					<td>En HIBATIS el SQL no se genera de manera automática por tanto es más simple y ocupa menos</td>
				</tr>
			</table>
		</section>

		<p>(Hay que cumplir la estructura basica indicada de secciones. Pero si se desea se pueden añadir otras
			secciones como anexos. Por ejemplo, alguna encuesta de opinion realizada sobre las tecnologías, etc.)</p>

	</main>

</body>

</html>
